import os

from flask_unchained import BundleConfig


class Config(BundleConfig):
    """
    Default configuration options for the webpack bundle.
    """

    WEBPACK_MANIFEST_PATH = (
        None if not BundleConfig.current_app.static_folder
        else os.path.join(BundleConfig.current_app.static_folder,
                          'assets', 'manifest.json'))
    """
    The full path to the ``manifest.json`` file generated by the Webpack ManifestPlugin.
    """


class ProdConfig(Config):
    """
    Default production configuration options for the webpack bundle.
    """

    # use relative paths by default, ie, the same host as the backend
    WEBPACK_ASSETS_HOST = ''
    """
    The host where Webpack assets are served from. Defaults to the same server as the
    backend.
    """


class StagingConfig(ProdConfig):
    pass
